-- only send to self, not broadcast to everyone
-- remove most othe code
-- only show once, do not repeat the same message
-- modified by jtbalogh

--			NotifySpellFailure_Reset();
--when out of combat ...


NotifySpellFailure_PrevArg = "";
NotifySpellFailure_Version = 1.0;

function NotifySpellFailure_OnLoad()
	NotifySpellFailure_Register();

	SLASH_NotifySpellFailure1 = "/NotifySpellFailure";
	SLASH_NotifySpellFailure2 = "/nsf";
	SlashCmdList["NotifySpellFailure"] = function(msg)
		NotifySpellFailure_SlashCommandHandler(msg);
	end
end

function NotifySpellFailure_SlashCommandHandler(msg)
	if (msg) then
		msg = string.lower(msg);
		local words = split(msg)
		local cmd, chan = words[1], words[2]

		if (cmd == "on") then
			NotifySpellFailure_Register();
			NotifySpellFailure_Sendmsg("|cFFee9966TR:|r NotifySpellFailure Enabled.");
		elseif (cmd == "off") then
			NotifySpellFailure_Unregister();
			NotifySpellFailure_Sendmsg("|cFFee9966TR:|r NotifySpellFailure Disabled.");
		else
			NotifySpellFailure_Sendmsg("|cFFee9966TR:|r Usage: /nsf on | off");
		end
	end
end

function split(str)
        local t = {}
        string.gsub(str, "%S+",
                    function(word) table.insert(t, word) end)
        return t
end

function NotifySpellFailure_Reset()
	NotifySpellFailure_PrevArg = "";
end

function NotifySpellFailure_OnEvent(event)
	if (event == "VARIABLES_LOADED") then
	end
	if (event == "PLAYER_ENTER_COMBAT") then
		NotifySpellFailure_Reset();
	end
	if (event == "PLAYER_LEAVE_COMBAT") then
		NotifySpellFailure_Reset();
	end
	if (event == "PLAYER_TARGET_CHANGED") then
		NotifySpellFailure_Reset();
	end
	if ((event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE") or (event == "CHAT_MSG_SPELL_SELF_DAMAGE")) then
		isFail = 1;
		if (strlower(string.sub(arg1, 1, string.len("Your"))) == strlower("your")) and not string.find(arg1, "hits") then
			if (NotifySpellFailure_PrevArg == arg1) then -- not show if duplicate
				isFail = nil;
			elseif string.find(arg1, "failed") then
			elseif string.find(arg1, "immune") then
			elseif string.find(arg1, "evaded") then
			elseif string.find(arg1, "resisted") then
			elseif string.find(arg1, "dodged") then
			elseif string.find(arg1, "parried") then
			elseif string.find(arg1, "blocked") then
			elseif string.find(arg1, "missed") then
			else
				isFail = nil;
			end
			if isFail then
				NotifySpellFailure_Sendcombatmsg("|cffffff00"..arg1.."|r");
				--local yellow = "|cffffff00"

				NotifySpellFailure_PrevArg = arg1;
			end
		end
	end
end

function NotifySpellFailure_Register()
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("VARIABLES_LOADED");
	NotifySpellFailure_Enabled = "on";
end

function NotifySpellFailure_Unregister()
	this:UnregisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE");
	this:UnregisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	this:UnregisterEvent("PLAYER_ENTER_COMBAT");
	this:UnregisterEvent("PLAYER_LEAVE_COMBAT");
	this:UnregisterEvent("PLAYER_TARGET_CHANGED");
	this:UnregisterEvent("VARIABLES_LOADED");
	NotifySpellFailure_Enabled = "off";
end

function NotifySpellFailure_Sendmsg(msg)
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage(msg, 1.0, 1.0, 1.0, 1.0);
	end
end

function NotifySpellFailure_Sendcombatmsg(msg)
	if (ChatFrame2) then
		ChatFrame2:AddMessage(msg, 1.0, 1.0, 1.0, 1.0);
	end
end
